JTB(1)

NAME
jtb - syntax tree builder for JavaCC

SYNOPSIS
jtb [options] inputfile

DESCRIPTION
This manual page documents briefly the jtb command.

JTB (Java Tree Builder) is a syntax tree builder and visitors generator to be used in front of JavaCC (Java Compiler Compiler). It takes a JavaCC grammar file as input (usually a ".jtb" file) and automatically generates the following:

    - a set of syntax tree classes based on the productions in the grammar, utilizing the Visitor design pattern;

    - four interfaces: IVoidVisitor, IVoidArguVisitor, IRetVisitor, IRetArguVisitor;

    - four depth-first visitors: DepthFirstVoidVisitor, DepthFirstVoidArguVisitor, DepthFirstRetVisitor, DepthFirstREtArguVisitor, whose default methods simply visit the children of the current node; a JavaCC grammar ".jj" file (jtb.out.jj by default), with the proper annotations to build the syntax tree during parsing (which then must be compiled with JavaCC).

New visitors, which subclass any generated one, can then override the default methods and perform various operations on and manipulate the generated syntax tree.

OPTIONS

-cl Print a list of the classes generated to standard out.

-d dir
    "-d dir" is short for (and overwrites) "-nd dir/syntaxtree -vd dir/visitor".

-dl Generate depth level info.

-e  Suppress JTB semantic error checking.

-f  Use descriptive node class field names.

-h  Display this help message and quit.

-ia Inline visitors accept methods on base classes.

-jd Generate JavaDoc-friendly comments in the nodes and visitor.

-nd NAME
    Use NAME as the package for the syntax tree nodes.

-np NAME
    Use NAME as the package for the syntax tree nodes.

-ns NAME
    Use NAME as the class which all node classes will extend.

-o NAME
    Use NAME as the filename for the annotated output grammar.

-p NAME
    "-p pkg" is short for (and overwrites) "-np pkg.syntaxtree -vp pkg.visitor".

-pp Generate parent pointers in all node classes.

-printer
    Generate a syntax tree dumping visitor.

-si Read from standard input rather than a file.

-scheme
    Generate Scheme records representing the grammar and a Scheme tree building visitor.

-tk Generate special tokens into the tree.

-vd NAME
    Use NAME as the package for the default visitor classes.

-vp NAME
    Use NAME as the package for the default visitor classes.

-w  Do not overwrite existing files.

SEE ALSO
javacc(1)

AUTHOR
jtb was written by the UCLA Compilers Group.

This manual page was written by David Paleino <dapal@debian.org>, for the Debian project (and may be used by others).

This manual page was updated by Ludovico Cavedon <cavedon@debian.org>.